/*
  SV3 - Main class for SV3 type interface ByVac
  Copyright (c) 2013 Jim Spence.  All right reserved.
  www.byvac.com - see terms and conditions for using hardware
  
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/  

// Version 1.0 r 2013 

#ifndef _H_sv3_h
#define _H_sv3_h

#include <inttypes.h>
#include <BSerial.h>


class SV3 : public BSerial
{
    public:
        // non-device specific
        SV3(uint8_t rxPin, uint8_t txPin, long baud, uint8_t raddr, uint8_t rack=6);
        void sv3_init();
        int active();
        void send(char *str);
        char getch_t();
        void wack();
        int read(char *buf);
        int id();
        void firmware(char *buf);
        void reset();
        void readEE(char from, char to, char *result);
        void writeEE(char location, char value);
    private:
        char _addr;
        char _ack;
};


#endif